如何面向面试学习？

我们提到面试，大多数人脑子里蹦出的第一个词，那就是八股文。但是面试真的可以**只**靠八股文吗？

那面试八股文重要吗？重要，非常重要！

那你这不是前后矛盾吗？一会说不能只靠八股文，一会又说八股文非常重要。

哎嘛，不要着急，听我慢慢说。

以下仅仅是我的一家之言。

我们先来看一下，一位 Javaer 校招需要准备的东西有哪些。

- 数据结构与算法

- 操作系统

- 计算机网络

- Java 基础

- MySQL

- Redis

- Java 并发编程

- Spring 全家桶

- Linux

- 设计模式
- 1-2 两个能拿得出手的项目。

上面的内容或多或少会在面试中问到，有的面试官侧重于项目，有的面试官喜欢问基础知识，也就是我们常说的八股，还有的面试官喜欢问实际开发中遇到的问题也就是场景题。但是我认为面试官在提问之前，他们心里已经有他们的答案，你如果能说出他心里的那个点，然后再对其延伸，则有可能让面试官眼前一亮的。但是如果你一直没有说出他想要的那个点，一昧的对其拓展，这个答案或许就有点些冗余。

或许面试时，面试官想要的状态是，看到你对技术的自信，知其然知其所以然。这样自然而然能够得到一个好的面评。

那么我们如何才能做到上面提到的呢？那就是看书，你会发现看过某个科目 2-3 遍书之后，你对这个科目是有自信的，因为你有这门科目的知识架构，有自己的理解，知道它们之间的联系，那么你回答时则会得心应手。记住是看 2-3 遍哦，一遍的话，只能大概了解大致脉络，不能让自己深刻理解，所以到重复看，你会发现那些好书，每次看的时候都会有新的收获。

那么面向面试，我们应该如何学习一项新科目呢？我们就以 MySQL（高频考点）来举例吧。

第一步：调研

这一步很好理解，我们需要了解该项技术的经典书籍，这样能我们学习时，事半功倍。我一般是自己进行搜索。现在是开源的时代，大家都很喜欢分享自己的心得，你可以通过知乎，论坛等搜索到某项科目的经典书籍，但是不要只看一个帖子，多看几个，这些帖子中多次提到的书籍。就是我们的学习目标。

![](https://img-blog.csdnimg.cn/a3bc62b23f994897a01d2f3a55b7463a.png)

另外你也可以问师兄师姐们，毕竟他们是过来人，知道哪些书籍值得读。

这里给大家推荐几本我读过的 MySQL 书籍，没有基础的同学可以按这个路线学习。

- MySQL 必知必会

  一本小册子，一天就能搞定，帮你快速入门 MySQL，另外大家在学习时，可以自己下载一下 MySQL 官方的学习库，然后自己动手实践一下，虽然速度慢了一些，但是能够让你学习的更加扎实。

  ![在这里插入图片描述](https://img-blog.csdnimg.cn/94505d023f6e4cf9ab179925ac7420a6.png)

  官方的 employees 库，我们可以用来练习一下，连接，explains 命令等。

- 数据库系统概论

  玫红色书皮的那本书，很多学校用来当作教材，这本书对数据库基础知识，查询语句，范式等讲的比较详细。这本书因为我之前学过几遍，后面再看的时候很快就读完了。个人认为还不错的一本书。有的学校研究生复试会考数据库，那么可以看下这本书，考点全面覆盖。

- 高性能 MySQL

  非常牛皮的一本书，很多知识点在里面讲的很细，适合进阶的同学，如果你看了这本书，面试时，常考的那些知识点，你就可以得心应手啦。

- MySQL 技术内幕

  这本书我没有完整的看下来，看了部分章节，比如那些常考的知识点，事务，索引等。也是非常棒的一本书，推荐给面试的同学。

- MySQL 45 讲

  这门课我看了大概百分之七十，前面的十几讲 看了大概 3-4 遍，每次都有新收获，这门课适合有一定基础的同学，如果没有学过 MySQL 的话，看的时候可能会有些吃力。

- 从根上理解 MySQL

  这个是掘金小册，也非常棒，但是我发现的有点晚了，后面抽着看了大概 1/2 吧。小册子对某个知识点说的很细，很透。

视频的话，我看的比较少，之前看过 MOOC 哈工大，战德臣 老师的课程，非常牛的一位老师，讲课风格也很棒，没有基础的同学可以看一下这个视频。

好啦，第一步一不小心扯多了，下面我们来说第二步。

第二步：看面经（八股）

啥？你刚才还说不能只看八股，这刚调研完经典书籍，就开始看八股了？这不是自己打自己脸吗？先别骂，先别骂，听我接着往下说。

这时的八股和面试题，是为了让你知道面试时的重点，哪些知识点常考，这样我们就可以重点看那些常考的章节。

那些不常考的知识点就不用看了吗？当然也是需要看的，因为每个章节之间是有联系的，通过前面的章节引出后面的，可以帮助我们更好的理解，形成自己的体系结构。不过这些不是重点的章节，可以粗略学习，了解即可。

第三步：看书

这一步我建议大家看纸质书，我们可以在书上标注，后面二刷三刷的时候，也可以根据标注帮我们回忆。大家可以在看书的时候，自己做一下思维导图，帮助我们构建自己的知识体系。推荐的软件是 Xmind，ProcessOn。

第四步：看面经和八股

注意，这里是看不是背，我们通过面经里的问题来进行归纳整理，对面经的问题进行分类，然后自己通过翻阅书籍和文章来找到答案进行整理，记住哈，记得分类，后面便于补充，也有利于搭建我们的知识体系。比如下面这样

![](https://img-blog.csdnimg.cn/92c846fe20ac4162960927a964b29bac.png)

第五步：回溯

哈哈，这个回溯不是我们刷题的那个回溯，而是我们对每次面试的总结，建议大家刚开始面试的时候可以对自己的面试过程进行录屏，面试结束后，查看录像，看看自己的言行举止等，是否有摇头晃脑，回答不自信等情况。

后面的话则只需录音即可，思考一下自己哪块回答的不太好，需要迭代，思考一下某个问题，面试官想要考察的点是什么。经历几次之后，就能找到自己的面试节奏和风格。

大家是不是发现学好一门课并不容易，也比较耗时，所以我们需要尽早的准备面试，早就是优势！

好啦，我要说的大概就这些啦，希望可以对学弟学妹们有一丢丢帮助。大家可以在评论区进行补充，推荐一下自己认为不错的书籍，今天就唠到这吧，拜了个拜。如果你需要我整理的面经 PDF ，可以添加我的微信，备注你需要的科目和 PDF ，例如 数据库 PDF。
